Skip to main content

Network Reconnaissance in IPv6 Networks
RFC 7707

Revision differences

Document history

Date Rev. By Action
2020-01-21
08 (System) Received changes through RFC Editor sync (added Verified Errata tag)
2017-10-31
08 (System) Received changes through RFC Editor sync (added Errata tag)
2016-03-09
08 (System) RFC published
2016-03-07
08 (System) RFC Editor state changed to AUTH48-DONE from AUTH48
2015-11-24
08 (System) RFC Editor state changed to AUTH48 from RFC-EDITOR
2015-11-05
08 (System) RFC Editor state changed to RFC-EDITOR from EDIT
2015-10-14
08 (System) Notify list changed from draft-ietf-opsec-ipv6-host-scanning.ad@ietf.org, draft-ietf-opsec-ipv6-host-scanning@ietf.org, draft-ietf-opsec-ipv6-host-scanning.shepherd@ietf.org, opsec-chairs@ietf.org, gunter@vandevelde.cc to (None)
2015-09-15
08 (System) IANA Action state changed to No IC from In Progress
2015-09-15
08 (System) IANA Action state changed to In Progress
2015-09-11
08 (System) RFC Editor state changed to EDIT
2015-09-11
08 (System) IESG state changed to RFC Ed Queue from Approved-announcement sent
2015-09-11
08 (System) Announcement was received by RFC Editor
2015-09-11
08 Amy Vezza IESG state changed to Approved-announcement sent from Approved-announcement to be sent
2015-09-11
08 Amy Vezza IESG has approved the document
2015-09-11
08 Amy Vezza Closed "Approve" ballot
2015-09-11
08 Amy Vezza Ballot approval text was generated
2015-09-11
08 Joel Jaeggli good to go now
2015-09-11
08 Joel Jaeggli IESG state changed to Approved-announcement to be sent from Approved-announcement to be sent::Point Raised - writeup needed
2015-09-01
08 Gunter Van de Velde Closed request for Last Call review by OPSDIR with state 'No Response'
2015-08-28
08 Fernando Gont IANA Review state changed to Version Changed - Review Needed from IANA OK - No Actions Needed
2015-08-28
08 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-08.txt
2015-08-20
07 Cindy Morgan IESG state changed to Approved-announcement to be sent::Point Raised - writeup needed from IESG Evaluation
2015-08-20
07 Alia Atlas [Ballot Position Update] New position, No Objection, has been recorded for Alia Atlas
2015-08-20
07 Kathleen Moriarty
[Ballot comment]
Thanks for your work pulling together a summary of reconnaissance techniques for IPv6.  I think this is a useful document, that will be …
[Ballot comment]
Thanks for your work pulling together a summary of reconnaissance techniques for IPv6.  I think this is a useful document, that will be helpful to operators and security professionals.  I don't have any comments to add that have not already been mentioned.
2015-08-20
07 Kathleen Moriarty [Ballot Position Update] New position, No Objection, has been recorded for Kathleen Moriarty
2015-08-19
07 Terry Manderson [Ballot Position Update] New position, No Objection, has been recorded for Terry Manderson
2015-08-19
07 Stephen Farrell
[Ballot comment]

- general: @Fernando: thank you for writing a document that does
not recommend turning off IPv6:-)

- general: shouldn't you recommend a honeynet …
[Ballot comment]

- general: @Fernando: thank you for writing a document that does
not recommend turning off IPv6:-)

- general: shouldn't you recommend a honeynet approach as another
way of spotting scans when there ought be none? That might fit in
3.5 I guess.

- intro: what evidence is there that the number of hosts per
subnet is likely to stay the same? (And what do you consider an
IPv4 subnet here? a /16 is it? Maybe worth saying.) The density
point still applies though, but good to not assume things that
aren't needed.

- 3.1.1 - I would recommend you check with Christian Huitema
about Windows10 which has some new features related to MAC
addresses. I don't know if there is new IPv6 handling associated
with those changes.

- 3.4.1 s/patters/patterns/
2015-08-19
07 Stephen Farrell [Ballot Position Update] New position, Yes, has been recorded for Stephen Farrell
2015-08-19
07 Ben Campbell [Ballot Position Update] New position, No Objection, has been recorded for Ben Campbell
2015-08-19
07 Jari Arkko [Ballot Position Update] New position, No Objection, has been recorded for Jari Arkko
2015-08-19
07 Alissa Cooper
[Ballot comment]
Interesting work, thanks.

On the VMWare ESX example given in Sec. 3.1.1.1, the OUI given for automatically-generated MAC addresses (00:05:59) does not seem …
[Ballot comment]
Interesting work, thanks.

On the VMWare ESX example given in Sec. 3.1.1.1, the OUI given for automatically-generated MAC addresses (00:05:59) does not seem correct. In the linked documentation, it is listed as 00:0C:29. In the IEEE OUI list, 00:0C:29 is registered to VMWare but 00:05:59 is registered to some other company.

In Sec. 3.1.1.3 and 3.1.1.4, I wonder if you might want to re-use the terminology from draft-ietf-6man-ipv6-address-generation-privacy in the section headings, in particular to differentiate "Constant" IIDs from "Stable" IIDs. I think this would be better than using "Privacy-Enhanced" as the term "privacy" is now overloaded when it comes to different types of v6 addresses.

I think the tables in 3.1.5 would be a lot more useful if the table captions noted the total number of addresses investigated (N).

In Section 3.5, wouldn't using RFC 4941 addresses count as a mitigation as well (first bullet)?

Sections 5-13 seem like they belong as subsections of an overarching section about "Other Network Reconnaissance Techniques" or some such. It might also help to provide some indication of how resource-intensive these techniques might be relative to each other. There are other application-specific ways of gathering information about active IP addresses that aren't listed here (the example that comes to mind is an attacker standing up a TURN server) but are probably also more trouble than they're worth for most attackers, which is presumably why they are not included in the list.
2015-08-19
07 Alissa Cooper [Ballot Position Update] New position, No Objection, has been recorded for Alissa Cooper
2015-08-19
07 Alvaro Retana
[Ballot comment]
Just a couple of nits: 

1. If this document obsoletes rfc5157, then it can’t really update it, can it?  You mention it …
[Ballot comment]
Just a couple of nits: 

1. If this document obsoletes rfc5157, then it can’t really update it, can it?  You mention it updates and obsoletes 5157 in the Abstract and Introduction.

2. Introduction.  I think you meant:  s/[van-Dijk] describes a technique for leveraging DNS reverse mappings for discovering IPv6 nodes./Section 4 describes a technique for leveraging DNS reverse mappings for discovering IPv6 nodes [van-Dijk]
2015-08-19
07 Alvaro Retana [Ballot Position Update] New position, No Objection, has been recorded for Alvaro Retana
2015-08-19
07 Deborah Brungard [Ballot Position Update] New position, No Objection, has been recorded for Deborah Brungard
2015-08-16
07 Martin Stiemerling [Ballot Position Update] New position, No Objection, has been recorded for Martin Stiemerling
2015-08-16
07 Spencer Dawkins
[Ballot comment]
I echo Barry's "nice document", and would support the changes he suggested.

I did notice what I believe is a repeated "not" in …
[Ballot comment]
I echo Barry's "nice document", and would support the changes he suggested.

I did notice what I believe is a repeated "not" in "it is not not only the lowest-order byte".

In this text:

3.4.1.  Remote IPv6 Network Scanners

  Many address scanning tools such as nmap [nmap2012] do not even
  support sweeping an IPv6 address range.
                          ^
does this mean "sweeping an IPv6 address range in a remote IPv6 network"? I think that's implicit from the section title, but what nmap supports is clearer in the corresponding text in the next section:

3.4.2.  Local IPv6 Network Scanners

  There are a variety of publicly-available local IPv6 network
  scanners:

  o  Current versions of nmap [nmap2012] implement this functionality.
2015-08-16
07 Spencer Dawkins [Ballot Position Update] New position, No Objection, has been recorded for Spencer Dawkins
2015-08-14
07 Barry Leiba
[Ballot comment]
Nice document you have here.  Just two really small comments, neither of which needs any response, and both of which you can ignore …
[Ballot comment]
Nice document you have here.  Just two really small comments, neither of which needs any response, and both of which you can ignore if you prefer.

An observation: Three times, you say that something is "obvious", and this can come across as condescending -- and can be frustrating to a reader for whom it isn't obvious.  I suggest omitting that, so

- In Section 3.1.1.1, change "Firstly, as it should be obvious from the algorithm described above" to "Firstly, as shown by the algorithm described above".

- In Section 3.1.3.2, change "For obvious reasons, the search space for addresses following" to "The search space for addresses following".

- In Section 3.3, change "Obviously, a number of other network reconnaissance vectors" to "A number of other network reconnaissance vectors".

-- Section 3.1.1.1 --

An observation, for which the response is probably "everyone knows this, so no change is needed," but please think about it for a fleeting moment:

  1.  The "Universal" bit (bit 6, from left to right) of the address is
      set to 1

Bit 6, starting from 0, or from 1?  The answer (which I can see from the example) is "starting from 0."

  Firstly, as it should be obvious from the algorithm described above,
  two bytes (bytes 4-5) of the resulting address always have a fixed
  value (0xff, 0xfe)

Bytes 4-5, starting from 0 or from 1?  The answer (which I can see from the example) is "starting from 1."

The fact that the origins differ makes me think that it'd be nice if that were made clear.  Please give it a thought, to say that bits are numbered from left to right starting at 0, and bytes are numbered from left to right starting at 1.
2015-08-14
07 Barry Leiba [Ballot Position Update] New position, No Objection, has been recorded for Barry Leiba
2015-08-02
07 Joel Jaeggli IESG state changed to IESG Evaluation from Waiting for Writeup
2015-08-02
07 Joel Jaeggli Placed on agenda for telechat - 2015-08-20
2015-08-02
07 Joel Jaeggli Ballot has been issued
2015-08-02
07 Joel Jaeggli [Ballot Position Update] New position, Yes, has been recorded for Joel Jaeggli
2015-08-02
07 Joel Jaeggli Created "Approve" ballot
2015-08-02
07 Joel Jaeggli Ballot writeup was changed
2015-08-02
07 Joel Jaeggli Changed consensus to Yes from Unknown
2015-07-17
07 Francis Dupont Request for Last Call review by GENART Completed: Ready. Reviewer: Francis Dupont.
2015-07-08
07 Tero Kivinen Request for Last Call review by SECDIR Completed: Has Nits. Reviewer: Dacheng Zhang.
2015-07-08
07 (System) IESG state changed to Waiting for Writeup from In Last Call
2015-06-30
07 Gunter Van de Velde Request for Last Call review by OPSDIR is assigned to Mahalingam Mani
2015-06-30
07 Gunter Van de Velde Request for Last Call review by OPSDIR is assigned to Mahalingam Mani
2015-06-29
07 (System) IANA Review state changed to IANA OK - No Actions Needed from IANA - Review Needed
2015-06-29
07 Pearl Liang
(Via drafts-lastcall@iana.org): IESG/Authors/WG Chairs:

IANA has reviewed draft-ietf-opsec-ipv6-host-scanning-07, which is currently in Last Call, and has the following comments:

We understand that, upon …
(Via drafts-lastcall@iana.org): IESG/Authors/WG Chairs:

IANA has reviewed draft-ietf-opsec-ipv6-host-scanning-07, which is currently in Last Call, and has the following comments:

We understand that, upon approval of this document, there are no IANA Actions that need completion. 

While it is helpful for the IANA Considerations section of the document to remain in place upon publication, if the authors prefer to remove it, IANA doesn't object.

If this assessment is not accurate, please respond as soon as possible.
2015-06-25
07 Jean Mahoney Request for Last Call review by GENART is assigned to Francis Dupont
2015-06-25
07 Jean Mahoney Request for Last Call review by GENART is assigned to Francis Dupont
2015-06-25
07 Tero Kivinen Request for Last Call review by SECDIR is assigned to Dacheng Zhang
2015-06-25
07 Tero Kivinen Request for Last Call review by SECDIR is assigned to Dacheng Zhang
2015-06-24
07 Amy Vezza IANA Review state changed to IANA - Review Needed
2015-06-24
07 Amy Vezza
The following Last Call announcement was sent out:

From: The IESG
To: IETF-Announce
CC:
Reply-To: ietf@ietf.org
Sender:
Subject: Last Call:  (Network Reconnaissance in IPv6 Networks) …
The following Last Call announcement was sent out:

From: The IESG
To: IETF-Announce
CC:
Reply-To: ietf@ietf.org
Sender:
Subject: Last Call:  (Network Reconnaissance in IPv6 Networks) to Informational RFC


The IESG has received a request from the Operational Security
Capabilities for IP Network Infrastructure WG (opsec) to consider the
following document:
- 'Network Reconnaissance in IPv6 Networks'
  as Informational RFC

The IESG plans to make a decision in the next few weeks, and solicits
final comments on this action. Please send substantive comments to the
ietf@ietf.org mailing lists by 2015-07-08. Exceptionally, comments may be
sent to iesg@ietf.org instead. In either case, please retain the
beginning of the Subject line to allow automated sorting.

Abstract


  IPv6 offers a much larger address space than that of its IPv4
  counterpart.  An IPv6 subnet of size /64 can (in theory) accommodate
  approximately 1.844 * 10^19 hosts, thus resulting in a much lower
  host density (#hosts/#addresses) than is typical in IPv4 networks,
  where a site typically has 65,000 or less unique addresses.  As a
  result, it is widely assumed that it would take a tremendous effort
  to perform address scanning attacks against IPv6 networks, and
  therefore brute-force IPv6 address scanning attacks have been
  considered unfeasible.  This document updates RFC 5157, which first
  discussed this assumption, by providing further analysis on how
  traditional address scanning techniques apply to IPv6 networks, and
  exploring some additional techniques that can be employed for IPv6
  network reconnaissance.  In doing so, this document formally
  obsoletes RFC 5157.




The file can be obtained via
https://datatracker.ietf.org/doc/draft-ietf-opsec-ipv6-host-scanning/

IESG discussion can be tracked via
https://datatracker.ietf.org/doc/draft-ietf-opsec-ipv6-host-scanning/ballot/


No IPR declarations have been submitted directly on this I-D.


2015-06-24
07 Amy Vezza IESG state changed to In Last Call from Last Call Requested
2015-06-24
07 Joel Jaeggli Last call was requested
2015-06-24
07 Joel Jaeggli Last call announcement was generated
2015-06-24
07 Joel Jaeggli Ballot approval text was generated
2015-06-24
07 Joel Jaeggli Ballot writeup was generated
2015-06-24
07 Joel Jaeggli IESG state changed to Last Call Requested from AD Evaluation
2015-06-07
07 Joel Jaeggli IESG state changed to AD Evaluation from Publication Requested
2015-05-30
07 Gunter Van de Velde
As required by RFC 4858, this is the current template for the Document
Shepherd Write-Up.

Changes are expected over time. This version is dated …
As required by RFC 4858, this is the current template for the Document
Shepherd Write-Up.

Changes are expected over time. This version is dated 24 February 2012.

(1) What type of RFC is being requested (BCP, Proposed Standard,
Internet Standard, Informational, Experimental, or Historic)?  Why
is this the proper type of RFC?  Is this type of RFC indicated in the
title page header?

<>Shepherd comment<>
Informational
<>/Shepherd comment<>

(2) The IESG approval announcement includes a Document Announcement
Write-Up. Please provide such a Document Announcement Write-Up. Recent
examples can be found in the "Action" announcements for approved
documents. The approval announcement contains the following sections:

Technical Summary

  Relevant content can frequently be found in the abstract
  and/or introduction of the document. If not, this may be
  an indication that there are deficiencies in the abstract
  or introduction.

<>Shepherd comment<>
IPv6 offers a much larger address space than that of its IPv4 counterpart.  An IPv6 subnet of size /64 can (in theory) accommodate approximately 1.844 * 10^19 hosts, thus resulting in a much lower host density (#hosts/#addresses) than is typical in IPv4 networks, where a site typically has 65,000 or less unique addresses.  As a result, it is widely assumed that it would take a tremendous effort to perform address scanning attacks against IPv6 networks, and therefore brute-force IPv6 address scanning attacks have been considered unfeasible.  This document updates RFC 5157, which first discussed this assumption, by providing further analysis on how traditional address scanning techniques apply to IPv6 networks, and exploring some additional techniques that can be employed for IPv6 network reconnaissance.  In doing so, this document formally obsoletes RFC 5157.
<>/Shepherd comment<>

Working Group Summary

  Was there anything in WG process that is worth noting? For
  example, was there controversy about particular points or
  were there decisions where the consensus was particularly
  rough?

<>Shepherd comment<>
No controversy. Document went pretty smooth in the WG
<>/Shepherd comment<>



Document Quality

  Are there existing implementations of the protocol? Have a
  significant number of vendors indicated their plan to
  implement the specification? Are there any reviewers that
  merit special mention as having done a thorough review,
  e.g., one that resulted in important changes or a
  conclusion that the document had no substantive issues? If
  there was a MIB Doctor, Media Type or other expert review,
  what was its course (briefly)? In the case of a Media Type
  review, on what date was the request posted?

<>Shepherd comment<>
The content is Informational experience and hence require no vendor implementation.
<>/Shepherd comment<>



Personnel

  Who is the Document Shepherd? Who is the Responsible Area
  Director?

<>Shepherd comment<>
Document Shepherd: Gunter Van de Velde
Responsible Area AD: Joel Jaeggli
<>/Shepherd comment<>


(3) Briefly describe the review of this document that was performed by
the Document Shepherd.  If this version of the document is not ready
for publication, please explain why the document is being forwarded to
the IESG.

<>Shepherd comment<>
Document Shepherd followed the document through its creation and this document is ready for publication. A final 1 week sanity check was requested on 21 April and WG consensus was voiced on document value to the list.
<>/Shepherd comment<>


(4) Does the document Shepherd have any concerns about the depth or
breadth of the reviews that have been performed? 

<>Shepherd comment<>
Depth and technical details are satisfactory
<>/Shepherd comment<>


(5) Do portions of the document need review from a particular or from
broader perspective, e.g., security, operational complexity, AAA, DNS,
DHCP, XML, or internationalization? If so, describe the review that
took place.

<>Shepherd comment<>
This document does not need broader review due to the nature of the document.
<>/Shepherd comment<>


(6) Describe any specific concerns or issues that the Document Shepherd
has with this document that the Responsible Area Director and/or the
IESG should be aware of? For example, perhaps he or she is uncomfortable
with certain parts of the document, or has concerns whether there really
is a need for it. In any event, if the WG has discussed those issues and
has indicated that it still wishes to advance the document, detail those
concerns here.

<>Shepherd comment<>
No specific concerns
<>/Shepherd comment<>


(7) Has each author confirmed that any and all appropriate IPR
disclosures required for full conformance with the provisions of BCP 78
and BCP 79 have already been filed. If not, explain why.

<>Shepherd comment<>
Fernando Gont: confirmed on list no awareness IPR.
Tim Chown: Confirmed to OPSEC chair through direct email that he is not aware of any IPR
<>/Shepherd comment<>


(8) Has an IPR disclosure been filed that references this document?
If so, summarize any WG discussion and conclusion regarding the IPR
disclosures.

<>Shepherd comment<>
No
<>/Shepherd comment<>


(9) How solid is the WG consensus behind this document? Does it
represent the strong concurrence of a few individuals, with others
being silent, or does the WG as a whole understand and agree with it? 

<>Shepherd comment<>
The WG agrees that this is a good document providing fine information.
<>/Shepherd comment<>


(10) Has anyone threatened an appeal or otherwise indicated extreme
discontent? If so, please summarise the areas of conflict in separate
email messages to the Responsible Area Director. (It should be in a
separate email because this questionnaire is publicly available.)

<>Shepherd comment<>
No particular negative emotions were expressed during the creation of this document
<>/Shepherd comment<>


(11) Identify any ID nits the Document Shepherd has found in this
document. (See http://www.ietf.org/tools/idnits/ and the Internet-Drafts
Checklist). Boilerplate checks are not enough; this check needs to be
thorough.

<>Shepherd comment<>
idnits were checked on 20 April and sent to authors for verification. Fernando commented that all idnits have been fully checked.
<>/Shepherd comment<>


(12) Describe how the document meets any required formal review
criteria, such as the MIB Doctor, media type, and URI type reviews.

<>Shepherd comment<>
No such reviews are needed
<>/Shepherd comment<>


(13) Have all references within this document been identified as
either normative or informative?

<>Shepherd comment<>
Yes
<>/Shepherd comment<>


(14) Are there normative references to documents that are not ready for
advancement or are otherwise in an unclear state? If such normative
references exist, what is the plan for their completion?

<>Shepherd comment<>
All Normative references are ready
<>/Shepherd comment<>



(15) Are there downward normative references references (see RFC 3967)?
If so, list these downward references to support the Area Director in
the Last Call procedure.

<>Shepherd comment<>
No
<>/Shepherd comment<>


(16) Will publication of this document change the status of any
existing RFCs? Are those RFCs listed on the title page header, listed
in the abstract, and discussed in the introduction? If the RFCs are not
listed in the Abstract and Introduction, explain why, and point to the
part of the document where the relationship of this document to the
other RFCs is discussed. If this information is not in the document,
explain why the WG considers it unnecessary.

<>Shepherd comment<>
This document intends to obsolete RFC 5157. This is indicated
<>/Shepherd comment<>


(17) Describe the Document Shepherd's review of the IANA considerations
section, especially with regard to its consistency with the body of the
document. Confirm that all protocol extensions that the document makes
are associated with the appropriate reservations in IANA registries.
Confirm that any referenced IANA registries have been clearly
identified. Confirm that newly created IANA registries include a
detailed specification of the initial contents for the registry, that
allocations procedures for future registrations are defined, and a
reasonable name for the new registry has been suggested (see RFC 5226).

<>Shepherd comment<>
This document makes no particular IANA considerations
<>/Shepherd comment<>


(18) List any new IANA registries that require Expert Review for future
allocations. Provide any public guidance that the IESG would find
useful in selecting the IANA Experts for these new registries.

<>Shepherd comment<>
This document makes no particular IANA allocation requests
<>/Shepherd comment<>

(19) Describe reviews and automated checks performed by the Document
Shepherd to validate sections of the document written in a formal
language, such as XML code, BNF rules, MIB definitions, etc.

<>Shepherd comment<>
IETF idnits tool
<>/Shepherd comment<>


2015-05-30
07 Gunter Van de Velde State Change Notice email list changed to draft-ietf-opsec-ipv6-host-scanning.ad@ietf.org, draft-ietf-opsec-ipv6-host-scanning@ietf.org, draft-ietf-opsec-ipv6-host-scanning.shepherd@ietf.org, opsec-chairs@ietf.org, gunter@vandevelde.cc
2015-05-30
07 Gunter Van de Velde Responsible AD changed to Joel Jaeggli
2015-05-30
07 Gunter Van de Velde IETF WG state changed to Submitted to IESG for Publication from WG Document
2015-05-30
07 Gunter Van de Velde IESG state changed to Publication Requested
2015-05-30
07 Gunter Van de Velde IESG process started in state Publication Requested
2015-05-30
07 Gunter Van de Velde Changed document writeup
2015-05-08
07 Gunter Van de Velde Changed document writeup
2015-04-30
07 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-07.txt
2015-02-05
06 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-06.txt
2015-01-19
05 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-05.txt
2014-07-16
04 Gunter Van de Velde Document shepherd changed to Gunter Van de Velde
2014-07-16
04 Gunter Van de Velde Intended Status changed to Informational from None
2014-06-14
04 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-04.txt
2014-01-23
03 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-03.txt
2013-07-15
02 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-02.txt
2013-04-30
01 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-01.txt
2012-12-12
00 Fernando Gont New version available: draft-ietf-opsec-ipv6-host-scanning-00.txt